/*
 * ff.h
 *
 * Fn prototypes for fast forward pass code
 *
 * 1999oct21 dpwe@icsi.berkeley.edu
 * $Header: /u/drspeech/src/ffwd/RCS/ff.h,v 1.2 1999/11/09 05:07:39 dpwe Exp $
 */

extern void
bunched_mlp2_forwprop_sm (
	  int Ni,     /* Number input units */
	  int Nh,     /* Number hidden units */
	  int No,     /* Number output units */
	  int Np,     /* number patterns in a bunch (i.e., bunch size). */
	  float *who, /* hidden to output weight matrix NoX(Nh+1) */
	  float *wih, /* input to hidden weight matrix NhX(Ni+1) */
	  /* for ipats and tpats, there are Np patterns (the bunch size)
	     and each one is a row in the corresponding matrix. */
	  float *ipats, /* input patterns  NpX(Ni+1) */
	  /* preallocated from the outside */
	  float *hpats,  /* hidden layer NpX(Nh+1) */
	  float *opats   /* output layer NpXNo */
	  ) ;

void *lmalloc(int bytes);
void write_matrix(char *fname,float*mat,int M,int N);
void read_matrix(char *fname,float*mat,int M,int N,int add_bias,float bval);
void bias_matrix(float *mat,int M,int N,float bval);

int readmlp3(char *fname, int ninp, int nhid, int nout, 
	     float *ihwts, float *howts);

#ifndef TRUE
#define TRUE (1)
#define FALSE (0)
#endif /* TRUE */

#define DEFBIASUNITVAL (-1.0)

