. $Header: /u/drspeech/src/simplebn/RCS/simplebn.man,v 1.2 2000/08/19 17:05:17 dpwe Exp $
.de PN
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.TH SIMPLEBN 1 "$Date: 2000/08/19 17:05:17 $" ICSI "ICSI SPEECH SOFTWARE"
.SH NAME
simplebn \- a simple batch-mode large-vocabulary speech recognizer
.SH SYNOPSIS
\fBsimplebn
[lang={\fIus\fB|\fIuk\fB}]
[ftrset=\fIset\fB]
[big_lm=\fIbool\fB]
[slow_search\fIbool\fB]
[use_chronos=\fIbool\fB]
[phn_decode=\fIbool\fB]
[verbose=\fIbool\fB]
[soundfile.in]
.SH DESCRIPTION
.PN simplebn
is a shell script that links together all the components of 
a simple speech-recognition system using the typical 
components used at ICSI.  
Speech data is read from a soundfile (or standard input) 
in any format known to 
.MS sndf 3
then converted to a standard format and sampling rate via
.MS sndrfmt 1
and
.MS sndrsmp 1 .
It is then converted to online features via 
.MS rasta 1 .
These are passed to the neural-net classifier, implemented by 
the fast stand-alone forward-pass program, 
.MS ffwd 1 ,
which uses the weights files distributed with 
this script (originally trained from the DARPA Hub4 data).
The posterior probabilities are then decoded into utterances by 
.MS noway 1 , 
which relies on prior, model, dictionary and trigram data files in this 
distribution.  The resulting word hypotheses are 
echoed to the standard output.
.SH OPTIONS
.TP
.B lang={\fIus\fB|\fIuk\fB}\fR ("us")
Select between models based on US Broadcast News ("us", the default) 
or British English BBC News ("uk").
.TP
.B ftrset=\fIset\fR ("plp12O")
Choose between several feature sets (and associated acoustic model files).
Options include "plp12" (plain PLP features), "plp12N" (per-utterance 
normalized PLP features), and the default "plp12O" (online-normalized). 
Note: only the acoustic models for plp12O are part of the distribution, 
so the other options will fail for users outside ICSI.
.TP
.B big_lm=\fIbool\fR (0)
Select a full 65,000 word vocabulary and grammar (rather than the default 
20,000 word one).  Again, this will fail unless you have specifically 
obtained these large files.  In any case, it works only with lang=us.
.TP
.B slow_search=\fIbool\fR (0)
Use much broader search pruning, for slower but more accurate performance.
On the test example (bill.wav), it takes approaching 10 times as long, 
but generates the same output!
.TP
.B use_chronos=\fIbool\fR (0)
Attempt to use the chronos decoder instead of the default noway.  
Chronos is small and fast, but is a proprietary product of SoftSound Inc., 
and is thus not part of the distribution.
.TP
.B phn_decode=\fIbool\fR (0)
Perform a phone-level decode rather than word level i.e. decode without 
applying the constraints of the dictionary, and report the result in 
terms of phones.  The data files for this are not included in the 
basic distribution.  Only available for lang=us.
.TP
.B verbose=\fIbool\fR (0)
Echo the actual commands being executed.
.SH FILES
.PN simplebn 
employs the following data files, by convention installed into 
/usr/local/models/simplebn :
.TP 12
boot-plp12O-70h-a4+117i+2000h+54o.wts
The neural net weights file trained from BN data.
.TP 0
 .. and a whole bunch of others too tedious to mention.
.SH EXAMPLE
To read 16 bit big-endian 16 kHz samples from standard input and 
write decoded words to standard output:
.EX
setenv PCMFORMAT EbR16
[ audio-producing command ] | simplebn
.EE
To convert a soundfile in a standard format (MSWAVE, AIFF, etc.) into 
the recognized words:
.EX
simplebn example.aif > example.txt
.EE
.SH ENVIRONMENT
.PN simplebn
relies on the standard \f4$DRSPEECH_PATH\f1 to find the various 
programs it uses.  
.P
The location of the data files should be 'baked-in' by the install 
process; however, this can be overridden by setting the \f4$SIMPLEBN_DATADIR\f1
environment variable.
.SH BUGS
.SH AUTHOR
Dan Ellis <dpwe@ICSI.Berkeley.EDU>
